searchNodes=[{"doc":"Protocol for implementing RTMP Message validators. Allows for verifying some of the RTMP messages.","ref":"Membrane.RTMP.MessageValidator.html","title":"Membrane.RTMP.MessageValidator","type":"protocol"},{"doc":"Validates the Membrane.RTMP.Messages.Publish.t/0 message.","ref":"Membrane.RTMP.MessageValidator.html#validate_publish/2","title":"Membrane.RTMP.MessageValidator.validate_publish/2","type":"function"},{"doc":"Validates the Membrane.RTMP.Messages.ReleaseStream.t/0 message.","ref":"Membrane.RTMP.MessageValidator.html#validate_release_stream/2","title":"Membrane.RTMP.MessageValidator.validate_release_stream/2","type":"function"},{"doc":"Validates the Membrane.RTMP.Messages.SetDataFrame.t/0 message.","ref":"Membrane.RTMP.MessageValidator.html#validate_set_data_frame/2","title":"Membrane.RTMP.MessageValidator.validate_set_data_frame/2","type":"function"},{"doc":"","ref":"Membrane.RTMP.MessageValidator.html#t:t/0","title":"Membrane.RTMP.MessageValidator.t/0","type":"type"},{"doc":"","ref":"Membrane.RTMP.MessageValidator.html#t:validation_result_t/0","title":"Membrane.RTMP.MessageValidator.validation_result_t/0","type":"type"},{"doc":"Default implementation of the MessageValidator protocol which allows every incoming stream.","ref":"Membrane.RTMP.MessageValidator.Default.html","title":"Membrane.RTMP.MessageValidator.Default","type":"module"},{"doc":"Defines the RTMP publish command.","ref":"Membrane.RTMP.Messages.Publish.html","title":"Membrane.RTMP.Messages.Publish","type":"module"},{"doc":"","ref":"Membrane.RTMP.Messages.Publish.html#t:t/0","title":"Membrane.RTMP.Messages.Publish.t/0","type":"type"},{"doc":"Defines the RTMP releaseStream command.","ref":"Membrane.RTMP.Messages.ReleaseStream.html","title":"Membrane.RTMP.Messages.ReleaseStream","type":"module"},{"doc":"","ref":"Membrane.RTMP.Messages.ReleaseStream.html#t:t/0","title":"Membrane.RTMP.Messages.ReleaseStream.t/0","type":"type"},{"doc":"Defines the RTMP setDataFrame command.","ref":"Membrane.RTMP.Messages.SetDataFrame.html","title":"Membrane.RTMP.Messages.SetDataFrame","type":"module"},{"doc":"","ref":"Membrane.RTMP.Messages.SetDataFrame.html#new/1","title":"Membrane.RTMP.Messages.SetDataFrame.new/1","type":"function"},{"doc":"","ref":"Membrane.RTMP.Messages.SetDataFrame.html#t:t/0","title":"Membrane.RTMP.Messages.SetDataFrame.t/0","type":"type"},{"doc":"Membrane element being client-side of RTMP streams. To work successfuly it requires to receive both audio and video streams in AAC and H264 format respectively. Currently it supports only: RTMP proper - &quot;plain&quot; RTMP protocol RTMPS - RTMP over TLS/SSL other RTMP variants - RTMPT, RTMPE, RTMFP are not supported. Implementation based on FFmpeg. Element options Passed via struct Membrane.RTMP.Sink.t/0 rtmp_url String . t ( ) Required Destination URL of the stream. It needs to start with rtmp:// or rtmps:// depending on the protocol variant. This URL should be provided by your streaming service. max_attempts pos_integer ( ) | :infinity Default value: 1 Maximum number of connection attempts before failing with an error. The attempts will happen every 500 ms Pads :video Accepted formats: MP4.Payload Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers :audio Accepted formats: AAC Direction: :input Availability: :always Mode: :pull Demand mode: :manual Demand unit: :buffers","ref":"Membrane.RTMP.Sink.html","title":"Membrane.RTMP.Sink","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTMP.Sink.html#options/0","title":"Membrane.RTMP.Sink.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTMP.Sink","ref":"Membrane.RTMP.Sink.html#t:t/0","title":"Membrane.RTMP.Sink.t/0","type":"type"},{"doc":"Membrane Element for receiving an RTMP stream. Acts as a RTMP Server. When initializing, the source sends socket_control_needed_t/0 notification, upon which it should be granted the control over the socket via :gen_tcp.controlling_process/2 . The Source allows for providing custom validator module, that verifies some of the RTMP messages. The module has to implement the Membrane.RTMP.MessageValidator behaviour. If the validation fails, a stream_validation_failed_t/0 notification is sent. This implementation is limited to only AAC and H264 streams. Element options Passed via struct Membrane.RTMP.Source.t/0 socket :gen_tcp . socket ( ) | :ssl . sslsocket ( ) Required Socket on which the source will be receiving the RTMP or RTMPS stream. The socket must be already connected to the RTMP client and be in non-active mode ( active set to false ). In case of RTMPS the use_ssl? options must be set to true. use_ssl? boolean ( ) Default value: false Tells whether the passed socket is a regular TCP socket or SSL one. validator Membrane.RTMP.MessageValidator . t ( ) Default value: %Membrane.RTMP.MessageValidator.Default{} A Membrane.RTMP.MessageValidator implementation, used for validating the stream. By default allows every incoming stream. Pads :output Accepted formats: Membrane.RemoteStream Direction: :output Availability: :always Mode: :pull Demand mode: :manual","ref":"Membrane.RTMP.Source.html","title":"Membrane.RTMP.Source","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTMP.Source.html#options/0","title":"Membrane.RTMP.Source.options/0","type":"function"},{"doc":"Notification sent when the RTMP Source element is initialized and it should be granted control over the socket using :gen_tcp.controlling_process/2 .","ref":"Membrane.RTMP.Source.html#t:socket_control_needed_t/0","title":"Membrane.RTMP.Source.socket_control_needed_t/0","type":"type"},{"doc":"Same as socket_control_needed_t/0 but for secured socket meant for RTMPS.","ref":"Membrane.RTMP.Source.html#t:ssl_socket_control_needed_t/0","title":"Membrane.RTMP.Source.ssl_socket_control_needed_t/0","type":"type"},{"doc":"Notification sent when the validator denies incoming RTMP stream.","ref":"Membrane.RTMP.Source.html#t:stream_validation_failed_t/0","title":"Membrane.RTMP.Source.stream_validation_failed_t/0","type":"type"},{"doc":"Notification sent when the validator approves given validation stage.","ref":"Membrane.RTMP.Source.html#t:stream_validation_success_t/0","title":"Membrane.RTMP.Source.stream_validation_success_t/0","type":"type"},{"doc":"Struct containing options for Membrane.RTMP.Source","ref":"Membrane.RTMP.Source.html#t:t/0","title":"Membrane.RTMP.Source.t/0","type":"type"},{"doc":"Notification sent when the socket has been closed but no media data has flown through it. This notification is only sent when the :output pad never reaches :start_of_stream .","ref":"Membrane.RTMP.Source.html#t:unexpected_socket_closed_t/0","title":"Membrane.RTMP.Source.unexpected_socket_closed_t/0","type":"type"},{"doc":"","ref":"Membrane.RTMP.Source.html#t:validation_stage_t/0","title":"Membrane.RTMP.Source.validation_stage_t/0","type":"type"},{"doc":"A simple ssl server, which handles each new incoming connection. The socket_handler function passed inside the options should take the socket returned by :ssl.handshake/1 and return {:ok, pid} , where the pid describes a process, which will be interacting with the socket. Membrane.RTMP.Source.SslServer will grant that process control over the socket via :ssl.controlling_process/2 .","ref":"Membrane.RTMP.Source.SslServer.html","title":"Membrane.RTMP.Source.SslServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Membrane.RTMP.Source.SslServer.html#child_spec/1","title":"Membrane.RTMP.Source.SslServer.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTMP.Source.SslServer.html#run/1","title":"Membrane.RTMP.Source.SslServer.run/1","type":"function"},{"doc":"","ref":"Membrane.RTMP.Source.SslServer.html#start_link/1","title":"Membrane.RTMP.Source.SslServer.start_link/1","type":"function"},{"doc":"Defines options for the SSL server. The listen_options are passed to the :ssl.listen/2 function. The socket_handler is a function that takes socket returned by :gen_tcp.accept/1 and returns the pid of a process, which will be interacting with the socket. SslServer will grant that process control over the socket via :ssl.controlling_process/2 .","ref":"Membrane.RTMP.Source.SslServer.html#t:t/0","title":"Membrane.RTMP.Source.SslServer.t/0","type":"type"},{"doc":"A simple tcp server, which handles each new incoming connection. The socket_handler function passed inside the options should take the socket returned by :gen_tcp.accept/1 and return {:ok, pid} , where the pid describes a process, which will be interacting with the socket. Membrane.RTMP.Source.TcpServer will grant that process control over the socket via :gen_tcp.controlling_process/2 .","ref":"Membrane.RTMP.Source.TcpServer.html","title":"Membrane.RTMP.Source.TcpServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Membrane.RTMP.Source.TcpServer.html#child_spec/1","title":"Membrane.RTMP.Source.TcpServer.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTMP.Source.TcpServer.html#run/1","title":"Membrane.RTMP.Source.TcpServer.run/1","type":"function"},{"doc":"","ref":"Membrane.RTMP.Source.TcpServer.html#start_link/1","title":"Membrane.RTMP.Source.TcpServer.start_link/1","type":"function"},{"doc":"Defines options for the TCP server. The listen_options are passed to the :gen_tcp.listen/2 function. The socket_handler is a function that takes socket returned by :gen_tcp.accept/1 and returns the pid of a process, which will be interacting with the socket. TcpServer will grant that process control over the socket via :gen_tcp.controlling_process/2 .","ref":"Membrane.RTMP.Source.TcpServer.html#t:t/0","title":"Membrane.RTMP.Source.TcpServer.t/0","type":"type"},{"doc":"Bin responsible for demuxing and parsing an RTMP stream. Outputs single audio and video which are ready for further processing with Membrane Elements. At this moment only AAC and H264 codecs are supported. Usage The bin requires the RTMP client to be already connected to the socket. The socket passed to the bin must be in non-active mode ( active set to false ). When the Membrane.RTMP.Source is initialized the bin sends Membrane.RTMP.Source.socket_control_needed_t/0 notification. Then, the control of the socket should be immediately granted to the Source with the pass_control/2 , and the Source will start reading packets from the socket. The bin allows for providing custom validator module, that verifies some of the RTMP messages. The module has to implement the Membrane.RTMP.MessageValidator protocol. If the validation fails, a Membrane.RTMP.Source.stream_validation_failed_t/0 notification is sent. Bin options Passed via struct Membrane.RTMP.SourceBin.t/0 socket :gen_tcp . socket ( ) | :ssl . sslsocket ( ) Required Socket, on which the bin will receive RTMP or RTMPS stream. The socket will be passed to the RTMP.Source . The socket must be already connected to the RTMP client and be in non-active mode ( active set to false ). In case of RTMPS the use_ssl? options must be set to true. use_ssl? boolean ( ) Default value: false Tells whether the passed socket is a regular TCP socket or SSL one. validator Membrane.RTMP.MessageValidator . t ( ) Default value: %Membrane.RTMP.MessageValidator.Default{} A Membrane.RTMP.MessageValidator implementation, used for validating the stream. By default allows every incoming stream. Pads :audio Accepted formats: AAC Direction: :output Availability: :always Mode: :pull Demand unit: :buffers :video Accepted formats: H264 Direction: :output Availability: :always Mode: :pull Demand unit: :buffers","ref":"Membrane.RTMP.SourceBin.html","title":"Membrane.RTMP.SourceBin","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTMP.SourceBin.html#options/0","title":"Membrane.RTMP.SourceBin.options/0","type":"function"},{"doc":"Passes the control of the socket to the source . To succeed, the executing process must be in control of the socket, otherwise {:error, :not_owner} is returned.","ref":"Membrane.RTMP.SourceBin.html#pass_control/2","title":"Membrane.RTMP.SourceBin.pass_control/2","type":"function"},{"doc":"Passes the control of the ssl socket to the source . To succeed, the executing process must be in control of the socket, otherwise {:error, :not_owner} is returned.","ref":"Membrane.RTMP.SourceBin.html#secure_pass_control/2","title":"Membrane.RTMP.SourceBin.secure_pass_control/2","type":"function"},{"doc":"Struct containing options for Membrane.RTMP.SourceBin","ref":"Membrane.RTMP.SourceBin.html#t:t/0","title":"Membrane.RTMP.SourceBin.t/0","type":"type"},{"doc":"This package provides RTMP server which receives an RTMP stream from a client and an element for streaming to an RTMP server. It is a part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane RTMP Plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_rtmp_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_rtmp_plugin , &quot;~&gt; 0.12.0&quot; } ] end","ref":"readme.html#installation","title":"Membrane RTMP Plugin - Installation","type":"extras"},{"doc":"Requires a socket, which has been connected to the client. It receives RTMP stream, demuxes it and outputs H264 video and AAC audio.","ref":"readme.html#sourcebin","title":"Membrane RTMP Plugin - SourceBin","type":"extras"},{"doc":"After establishing connection with server it waits to receive video and audio streams. Once both streams are received they are streamed to the server. Currently only the following codecs are supported: H264 for video AAC for audio","ref":"readme.html#client","title":"Membrane RTMP Plugin - Client","type":"extras"},{"doc":"It's a simple implementation of tcp server. It opens a tcp port and listens for incoming connections. For each new connection, a user-provided function is executed. Prerequisites In order to successfully build and install the plugin, you need to have ffmpeg == 4.4 installed on your system","ref":"readme.html#tcp-server","title":"Membrane RTMP Plugin - TCP Server","type":"extras"},{"doc":"RTMP receiver Server-side example, in which Membrane will act as an RTMP server and receive the stream, can be found under examples/source.exs . Run it with: elixir examples/source.exs When the server is ready you can connect to it with RTMP. If you just want to test it, you can use FFmpeg: ffmpeg -re -i test/fixtures/testsrc.flv -f flv -c:v copy -c:a copy rtmp://localhost:5000 Streaming with RTMP Streaming implementation example is provided with the following examples/sink.exs . Run it with: elixir examples/sink.exs It will connect to RTMP server provided via URL and stream H264 video and AAC audio. RTMP server that will receive this stream can be launched with ffmpeg by running the following commands: export RTMP_URL=rtmp://localhost:1935 ffmpeg -y -listen 1 -f flv -i rtmp://localhost:1935 -c copy dest.flv It will receive stream and once streaming is completed dump it to .flv file. If you are using the command above, please remember to run it before the streaming script.","ref":"readme.html#usage","title":"Membrane RTMP Plugin - Usage","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane RTMP Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]